初次刷LeetCode---Two Sun

总结(反省):

    1、不知道如何下手,没看懂要求   

        实际上只是写出求解问题的方法,参数之类的在方法参数列表中已传。

    2、数组的长度arr.length,已经模糊

    3、for循环从0开始,竟然到arr.length结束

for(int i = 0; i <= arr.length;i++){
    ...
}

    4、方法返回值的忽略

-----------------------------------------------------------------------------------------------------------------------------------

以下是自己与答案之间的对比(感觉自己很差劲):

自己的:

public int[] twoSum(int[] nums, int target) {
        int[] arr = new int[2];
        for(int i = 0;i < nums.length;i++){
            for(int j = i + 1;j < nums.length ; j++){
                if(nums[i]+nums[j]==target){
                    arr[0] = i;
                    arr[1] = j; 
                }
            }
        }
        return arr;
    }

答案:

public int[] twoSum(int[] nums, int target) {
    for (int i = 0; i < nums.length; i++) {
        for (int j = i + 1; j < nums.length; j++) {
            if (nums[j] == target - nums[i]) {
                return new int[] { i, j };
            }
        }
    }
    throw new IllegalArgumentException("No two sum solution");
}

不仅如此,上面的答案只是一种蛮力(Brute Force)求解的过程,根本没有编程之美( ∩_∩ ,自我狼狈中~~)

这里给个好的(One-pass Hash Table):

public int[] twoSum(int[] nums, int target) {
    Map<Integer, Integer> map = new HashMap<>();
    for (int i = 0; i < nums.length; i++) {
        int complement = target - nums[i];
        if (map.containsKey(complement)) {
            return new int[] { map.get(complement), i };
        }
        map.put(nums[i], i);
    }
    throw new IllegalArgumentException("No two sum solution");
}

下面给出链接 可以自己去体验

https://leetcode.com/articles/two-sum/

-----------------------------------------------------------------------------------------------------------------------------------原题:

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

翻译:

给定一组整数,将两个数的返回指数相加,使它们相加成一个特定的目标。
您可以假设每个输入都有一个解决方案,您可能不会使用相同的元素两次。



    
  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值